#ifndef gf_included_cordy_h
#define gf_included_cordy_h

struct cordy
{
 int TopLeftX, TopLeftY;
 int BottomRightX, BottomRightY;
};

typedef struct cordy Cordy;

Cordy CreateNewCordy(int TopX, int TopY, int BottomX, int BottomY);

/*
The whole point of Cordy is to provide two important co-ordinates.  The top left of the
current piece that's moving through the GameGrid and the bottom right corner.  This is
to ensure that I'm only working with the important part of the GameGrid and not ALL of it.

Basically this saves me some time.  Also, if the co-ords are ever negative, I know that
the piece is close to an edge and I have to be careful when I'm writing the movement of
the piece so as not to go outside the GameGrid area.
*/

#endif
