#include <stdlib.h>
#include "piece.h"
#include "gamegrid.h"

/*
This function determines the speed of the game, depending on the level of the playing field.
The formula was provided by Cecile, and she's in the credits :)
*/

int DecideSpeed(int Level)
{
 if(Level == 0) return 130;
 else if(Level == 1) return 110;
 else if(Level == 2) return 100;
 else if(Level == 3) return 90;
 else if(Level == 4) return 80;
 else if(Level == 5) return 70;
 else if(Level == 6) return 65;
 else if(Level == 7) return 55;
 else if(Level == 8) return 45;
 else if(Level == 9) return 40;
 else if(Level == 10) return 35;
 else if(Level == 11) return 30;
 else if(Level == 12) return 25;
 else if(Level == 13) return 22;
 else if(Level == 14) return 18;
 else if(Level == 15) return 15;
 else if(Level == 16) return 13;
 else if(Level == 17) return 12;
 else if(Level == 18) return 11;
 else if(Level == 19) return 10;
 else if(Level == 20) return 9; 
 else return 8;
}

/*
This little and stupid helper function only determines the multiplier based on level.
*/
int FindMultiplier(int Level)
{
 int Mult = Level / 2;
 if(Mult < 1) Mult = 1;

 return Mult;
}

/*
Sets us up to play.
*/
GameGrid InitializeGrid(int StartLevel, int MaxLevel, int LinesRequired)
{
 GameGrid theGrid;

 theGrid.GridHeight = STARTGRIDHEIGHT;
 theGrid.GridWidth = STARTGRIDWIDTH;
 theGrid.CurrentColour = 0;
 theGrid.Lose = 0;
 theGrid.CurrentLevel = StartLevel;
 theGrid.MaxLevel = MaxLevel;
 theGrid.GoDown = 1;
 theGrid.ScoreCounter = 0;
 theGrid.BumpMeUp = 0;
 theGrid.NeedNewPiece = 1;
 theGrid.Score = 0;
 theGrid.Speed = DecideSpeed(theGrid.CurrentLevel);
 theGrid.LinesRequired = LinesRequired;
 theGrid.Multiplier = FindMultiplier(theGrid.CurrentLevel);
 theGrid.LinesClear = 0;

 int nextValue = rand() % 7;
 theGrid.PieceQ.head = NULL;
 theGrid.PieceQ = enqueue(theGrid.PieceQ, nextValue);
 theGrid.NextPiece = GeneratePiece(HeadValue(theGrid.PieceQ));
 theGrid.PieceQ = dequeue(theGrid.PieceQ);
 nextValue = rand() % 7;
 theGrid.PieceQ = enqueue(theGrid.PieceQ, nextValue); 

 int row,column;
 for(row = 0; row < theGrid.GridHeight; row++)
   {	// We need to clean the array before we use it.
    for(column = 0; column < theGrid.GridWidth; column++)
    {
     theGrid.BlockArray[row][column][0] = 0;
     theGrid.BlockArray[row][column][1] = 0;
     theGrid.BlockArray[row][column][2] = 0;
    }
   } 
 
 return theGrid;
}

/*
This function takes the next piece and sets it to current piece.  We then create a cordy
for this piece so that we can keep track of where it is in the playing field ( that way
we don't have to check the whole damn thing whenever the player does something ).

You'll notice that I don't use the first row in the playing field.  That's because if
I do, I get a segmentation fault.  I still haven't figured this one out, but I'm just
going to leave it there.  If you can figure out the flaw in my current logic, please
feel free to e-mail me.
*/
GameGrid NextPiece(GameGrid theGrid)
{
 int row;
 int column;
 theGrid.CurrentPiece = theGrid.NextPiece;
 theGrid.CurrentPiece.currentCordy = CreateNewCordy(3, 1, 2+theGrid.CurrentPiece.ArraySize, theGrid.CurrentPiece.ArraySize);

 theGrid.CurrentColour = ((theGrid.CurrentPiece.Colour + theGrid.CurrentLevel) % 15) + 1;

 for(row = 0; row < theGrid.CurrentPiece.ArraySize; row++)
  {
   for(column = 0; column < theGrid.CurrentPiece.ArraySize; column++)
   {
    theGrid.BlockArray[row+theGrid.CurrentPiece.currentCordy.TopLeftY][column+theGrid.CurrentPiece.currentCordy.TopLeftX][0] = theGrid.CurrentPiece.PieceArray[row][column];
    if((theGrid.BlockArray[row+theGrid.CurrentPiece.currentCordy.TopLeftY][column+theGrid.CurrentPiece.currentCordy.TopLeftX][1] > 0) &&
      (theGrid.BlockArray[row+theGrid.CurrentPiece.currentCordy.TopLeftY][column+theGrid.CurrentPiece.currentCordy.TopLeftX][0] > 0))       
      theGrid.Lose = 1; 

    /*We copy the piece array into the first layer of the playing field.  From now on,
      we don't even bother with CurrentPiece, unless we need to run some tests on movement.
      If while copying, we land ontop of a block that's already there, the player dies.
    */
   }
  }

 return theGrid;
}

/*
For this function, we start at a line and just overwrite it with the line on top.  We 
continue until we get to the top.  Remember, I don't use the first row, and it's just
a bunch of zeros.  So I simply push it down and can forget about it, since it isn't part
of the played game.
*/
GameGrid ClearLine(GameGrid theGrid, int row)
{
 int startRow,column;
 
 for(startRow = row; startRow > 0; startRow--)
 {
  for(column = 0; column < theGrid.GridWidth; column++) 
  {
    theGrid.BlockArray[startRow][column][1] = theGrid.BlockArray[startRow-1][column][1];   
    theGrid.BlockArray[startRow][column][2] = theGrid.BlockArray[startRow-1][column][2];   
  }
 }

 return theGrid; 	
}

/*
Bump all the lines up by 1, and in the new row, just generate random blocks.
You'll notice that a lot of these functions have two parts to them.
First:  Can we actually do what this function needs to do?
Second: Do it.

So the first part usually involves a variable called MakeTransfer.  If after all 
of our rigorous testing, MakeTransfer remains true, then we simply do what we were
called for.
*/

GameGrid BumpUp(GameGrid theGrid)
{
 int row = 1;
 int column;
 int MakeTransfer = 1;
 //If the topmost playing column has stuff in it, then we can't bump up.
 for(column = 0; column < theGrid.GridWidth; column++)
 {
  if(theGrid.BlockArray[row][column][1] == 1) MakeTransfer = 0;
 }

 if(MakeTransfer)
 {
  for(row = 0; row < theGrid.GridHeight-1; row++)
  {
    for(column = 0; column < theGrid.GridWidth; column++)
    { //Just move all the rows up by one.
     theGrid.BlockArray[row][column][1] = theGrid.BlockArray[row+1][column][1];
     theGrid.BlockArray[row][column][2] = theGrid.BlockArray[row+1][column][2];
    }
  }

  //Now clean the bottom before we use it.
  for(column = 0; column < theGrid.GridWidth; column++)
  {
    theGrid.BlockArray[theGrid.GridHeight-1][column][1] = 0;
    theGrid.BlockArray[theGrid.GridHeight-1][column][2] = 0;
  }  

  //Penalty lines (or trash) always consist of 7 randomnly placed blocks.
  int RandomNumberBlocks = 7;
  column = 0;
  while(RandomNumberBlocks)
  {
   int Randomize = rand() % 2; //Either we place one or we don't.  1 or 0.
   // If we have a block to place down, we still have blocks left, AND this position is still empty...
   if(Randomize && RandomNumberBlocks && theGrid.BlockArray[theGrid.GridHeight-1][column%theGrid.GridWidth][1] == 0)
   {
    //Put it there.
     theGrid.BlockArray[theGrid.GridHeight-1][column%theGrid.GridWidth][1] = 1;
     theGrid.BlockArray[theGrid.GridHeight-1][column%theGrid.GridWidth][2] = 1;
     RandomNumberBlocks--;  //We have one less to work with.
   }
   column++;
  }
 }
 else theGrid.Lose = 1;
 //If we can't bump up, the player has run out of room and is now dead.
 return theGrid; 	 
}

/*
Check the lines that are currently being used by the current piece.  If any of them have been completely filled, then
clear it.
*/
GameGrid CheckLines(GameGrid theGrid)
{
 int row, column;
 int LineChecker = 0;
 theGrid.ScoreCounter = 0;

 //Start at the top and work our way down.  We're really only checking 2-4 lines.
 for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
 {
  if(row >=0 && row < theGrid.GridHeight)
  {
   //Assume that clearing the line is true.
   LineChecker = 1;
   for(column = 0; column < theGrid.GridWidth; column++)
   {
    if(!theGrid.BlockArray[row][column][1])
    {
     column = theGrid.GridWidth;
     LineChecker = 0;  //Oh, found an empty space?  I guess it isn't true after all.
    }
   }

   if(LineChecker)  	
   {
    theGrid = ClearLine(theGrid, row);  // Clear that pesky line.
    theGrid.LinesClear = theGrid.LinesClear + 1;  //Well, we got one more.
    if((theGrid.LinesClear % theGrid.LinesRequired == 0) && theGrid.CurrentLevel < theGrid.MaxLevel)
    {
     theGrid.CurrentLevel += 1;  //If we cleared enough lines and we still have room to go, then go up by one.
     theGrid.Speed = DecideSpeed(theGrid.CurrentLevel);  //figure out the new speed.
     theGrid.Multiplier = FindMultiplier(theGrid.CurrentLevel);  //Well, get the new multiplier.
    }

    theGrid.ScoreCounter++;  // Since we cleared one more line, we may get even more points then normal.
   }
  }

  //If we actually have a ScoreCounter, it means we cleared lines.  ScoreCounter is reset to 0 by the driver, because
  //it is actually used to determine penalties on the other player.
  //Scoring explained in the help file.
  if(theGrid.ScoreCounter < 4) theGrid.Score += 40 * theGrid.ScoreCounter * theGrid.ScoreCounter * (theGrid.Multiplier);
  else theGrid.Score += 1000 * (theGrid.Multiplier);
 }

 return theGrid;
}

/*
This is easy.  It's also where those functions above get called.  If we get a call to stop the piece, then we take where
it is right now and put it on the layer below.  Then we check the lines, clear the lines, and bump the player up if he's
been penalized at all from before.
*/
GameGrid StopPiece(GameGrid theGrid)
{
 int row, column;
 
 for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
 {
  for(column = theGrid.CurrentPiece.currentCordy.TopLeftX; column <= theGrid.CurrentPiece.currentCordy.BottomRightX; column++)
  {
   if((row >= 0 && row < theGrid.GridHeight) && (column >= 0 && column < theGrid.GridWidth))
   {
     if(theGrid.BlockArray[row][column][0] == 1) 
     {
      theGrid.BlockArray[row][column][0] = 0;
      theGrid.BlockArray[row][column][1] = 1;
      theGrid.BlockArray[row][column][2] = theGrid.CurrentColour;  // We take the current piece's colour and record it for posterity.
     }
   }
  }
 }
 theGrid = CheckLines(theGrid);

 //While we still have penalties to hand out, bump him up.
 while(theGrid.BumpMeUp > 0)
 {
  theGrid = BumpUp(theGrid);
  theGrid.BumpMeUp--;
 }

 //Get our next piece and put it on the field.
 theGrid = NextPiece(theGrid); 
 theGrid.NeedNewPiece = 1;  //Now we need a new one, so tell the driver.
 theGrid.GoDown = 0;  // We can no longer take the last piece down, so tell the driver.

 return theGrid;
}

/*
If we can make the transfer, then we push the piece down by 1.  Otherwise we stop the piece and do what is listed above.

Can we make the transfer?  Well, check the space below it.  If there are blocks there, then we have to stop where we are.
You'll notice that I make a lot of checks to see if I've gone outside the playing field.  This is necessary, because if
I try to manipulate data outside the array, then it dies.  So, if the piece is at the bottom, but the piece goes off the
edge of the map, I just leave it alone and let it do it's thing without looking at what's off the edge.
*/
GameGrid MoveDown(GameGrid theGrid)
{
 int row;
 int column;
 int MakeTransfer = 1;
 
 for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
 {
  for(column = theGrid.CurrentPiece.currentCordy.TopLeftX; column <= theGrid.CurrentPiece.currentCordy.BottomRightX; column++)
  {
   if(row < theGrid.GridHeight)
   {
    if(theGrid.BlockArray[row][column][0] == 1)
    {
     if(row+1 >= theGrid.GridHeight)
        MakeTransfer = 0;
     else if(theGrid.BlockArray[row+1][column][1] == 1)
        MakeTransfer = 0;
    }
   }
  }
 }

 if(MakeTransfer)
 {
  for(row = theGrid.CurrentPiece.currentCordy.BottomRightY; row >= theGrid.CurrentPiece.currentCordy.TopLeftY; row--)
  {
   for(column = theGrid.CurrentPiece.currentCordy.BottomRightX; column >= theGrid.CurrentPiece.currentCordy.TopLeftX; column--)
   {
    if((row+1 < theGrid.GridHeight && row >= 0) && (column < theGrid.GridWidth && column >=0))
      theGrid.BlockArray[row+1][column][0] = theGrid.BlockArray[row][column][0];
   }  
  }
  
  for(column = theGrid.CurrentPiece.currentCordy.TopLeftX; column <= theGrid.CurrentPiece.currentCordy.BottomRightX; column++)
    theGrid.BlockArray[theGrid.CurrentPiece.currentCordy.TopLeftY][column][0] = 0;

  //The cordy obviously gets bumped down.  You'll notice cordy movements in the other move functions.

  theGrid.CurrentPiece.currentCordy.TopLeftY++;
  theGrid.CurrentPiece.currentCordy.BottomRightY++;
 }
 else return StopPiece(theGrid);


 return theGrid;
}

/*
The following two functions are obvious.  Check to see if the piece runs into a wall, and then check to see if it runs into
any blocks beside it.  If not, move it, otherwise forget it.
*/

GameGrid MoveLeft(GameGrid theGrid)
{
 int row;
 int column;
 int MakeTransfer = 1;

 for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
 {
  if(row < theGrid.GridHeight && row >= 0)
  {
   for(column = theGrid.CurrentPiece.currentCordy.TopLeftX; column <= theGrid.CurrentPiece.currentCordy.BottomRightX; column++)
   {
    if(column >= 0)
    {
     if(theGrid.BlockArray[row][column][0] == 1)
     {
      if(column <= 0)
         MakeTransfer=0;
      else if(theGrid.BlockArray[row][column-1][1] == 1)
          MakeTransfer = 0;
     }
    }
   } 
  }
 }

 if(MakeTransfer)
 {
  for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
  {
   for(column = theGrid.CurrentPiece.currentCordy.TopLeftX; column <= theGrid.CurrentPiece.currentCordy.BottomRightX; column++)
   {
    if(row < theGrid.GridHeight && row >= 0)
      theGrid.BlockArray[row][column-1][0] = theGrid.BlockArray[row][column][0];
   }
  }    

  for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
  {
   if(row < theGrid.GridHeight && row >= 0)
   {
     if(theGrid.CurrentPiece.currentCordy.BottomRightX >= theGrid.GridWidth) theGrid.BlockArray[row][theGrid.GridWidth-1][0] = 0;
     else theGrid.BlockArray[row][theGrid.CurrentPiece.currentCordy.BottomRightX][0] = 0;
   }
  } 

  theGrid.CurrentPiece.currentCordy.TopLeftX--;
  theGrid.CurrentPiece.currentCordy.BottomRightX--;    
 }	


 return theGrid;
}

GameGrid MoveRight(GameGrid theGrid)
{ 
 int row;
 int column;
 int MakeTransfer = 1;

 for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
 {
  if(row < theGrid.GridHeight && row >= 0)
  {
   for(column = theGrid.CurrentPiece.currentCordy.TopLeftX; column <= theGrid.CurrentPiece.currentCordy.BottomRightX; column++)
   {
    if(column < theGrid.GridWidth)
    {
     if(theGrid.BlockArray[row][column][0] == 1)
     {
      if(column+1 >= theGrid.GridWidth) MakeTransfer = 0;
      else if(theGrid.BlockArray[row][column+1][1] == 1)
        MakeTransfer = 0;
     }
    }
   }
  }
 }  

 if(MakeTransfer)
 {
  for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
  {
   for(column = theGrid.CurrentPiece.currentCordy.BottomRightX; column >= theGrid.CurrentPiece.currentCordy.TopLeftX; column--)
   {
    if(row < theGrid.GridHeight && row >= 0)
      theGrid.BlockArray[row][column+1][0] = theGrid.BlockArray[row][column][0];
   }
  }

  for(row = theGrid.CurrentPiece.currentCordy.TopLeftY; row <= theGrid.CurrentPiece.currentCordy.BottomRightY; row++)
  {
   if(row < theGrid.GridHeight && row >= 0)
   {
    if(theGrid.CurrentPiece.currentCordy.TopLeftX < 0) theGrid.BlockArray[row][0][0] = 0;
    else theGrid.BlockArray[row][theGrid.CurrentPiece.currentCordy.TopLeftX][0] = 0;
   }
  }  

  theGrid.CurrentPiece.currentCordy.TopLeftX++;
  theGrid.CurrentPiece.currentCordy.BottomRightX++;  
 }	



 return theGrid;
}

/*
You'll notice for the next two functions that I manipulate a test piece first.  That's because I want to see if it works.
If there's a conflict with the playing field or I go out of bounds with the new piece, then I can't rotate.  If I can rotate
it, then I do.  THEN I need to overwrite the current first layer of the playing field, because it has the old version of
the piece.
*/

GameGrid Clockwise(GameGrid theGrid)
{
 Piece testPiece = theGrid.CurrentPiece;

 int row;
 int column;
 int MakeTransfer = 1;

 testPiece = RotateClockwise(testPiece);

 if((theGrid.CurrentPiece.currentCordy.TopLeftX < 0) || 
    (theGrid.CurrentPiece.currentCordy.BottomRightX >= theGrid.GridWidth) ||
    (theGrid.CurrentPiece.currentCordy.BottomRightY >= theGrid.GridHeight))
 {
    MakeTransfer = 0;
 }
 else
 {
  for(row = 0; row < testPiece.ArraySize; row++)
  {
   for(column = 0; column < testPiece.ArraySize; column++)
   {
    if((theGrid.BlockArray[row+testPiece.currentCordy.TopLeftY][column+testPiece.currentCordy.TopLeftX][1] == 1) &&
       (testPiece.PieceArray[row][column] == 1))
      MakeTransfer = 0;
   }
  }
 }

 if(MakeTransfer)
 {
  theGrid.CurrentPiece = RotateClockwise(theGrid.CurrentPiece);
  
  for(row = 0; row < theGrid.CurrentPiece.ArraySize; row++)
  {
   for(column = 0; column < theGrid.CurrentPiece.ArraySize; column++)
   {
    theGrid.BlockArray[row+theGrid.CurrentPiece.currentCordy.TopLeftY][column+theGrid.CurrentPiece.currentCordy.TopLeftX][0] = theGrid.CurrentPiece.PieceArray[row][column];
   }	
  }
 }
 

 return theGrid;	
}

GameGrid Counter_Clockwise(GameGrid theGrid)
{
 Piece testPiece = theGrid.CurrentPiece;

 int row;
 int column;
 int MakeTransfer = 1;

 testPiece = RotateCounter_Clockwise(testPiece);

 if((theGrid.CurrentPiece.currentCordy.TopLeftX < 0) || 
    (theGrid.CurrentPiece.currentCordy.BottomRightX >= theGrid.GridWidth) ||
    (theGrid.CurrentPiece.currentCordy.BottomRightY >= theGrid.GridHeight))
 {
    MakeTransfer = 0;
 }
 else
 {
  for(row = 0; row < testPiece.ArraySize; row++)
  {
   for(column = 0; column < testPiece.ArraySize; column++)
   {
    if((theGrid.BlockArray[row+testPiece.currentCordy.TopLeftY][column+testPiece.currentCordy.TopLeftX][1] == 1) &&
       (testPiece.PieceArray[row][column] == 1))
      MakeTransfer = 0;
   }
  }
 }

 if(MakeTransfer)
 {
  theGrid.CurrentPiece = RotateCounter_Clockwise(theGrid.CurrentPiece);
  
  for(row = 0; row < theGrid.CurrentPiece.ArraySize; row++)
  {
   for(column = 0; column < theGrid.CurrentPiece.ArraySize; column++)
   {
    theGrid.BlockArray[row+theGrid.CurrentPiece.currentCordy.TopLeftY][column+theGrid.CurrentPiece.currentCordy.TopLeftX][0] = theGrid.CurrentPiece.PieceArray[row][column];
   }	
  }
 }
 return theGrid;	
}
