#include <stdlib.h>
#include "piece.h"


/*
You'll notice many functions for creating each of the seven types of pieces.  First I give it size, then a type, then a 
colour, and finally I initialize the entire part of the array I'll use.  I use the top left corner and leave all else
at zero if not used.

Again, the colour values will be changed when I'm NOT using ascii.  Right now, this is the initial value of the colours.
You notice a colour change in the game between levels, because the GameGrid actually uses the Piece colour as a place
to start.
*/

Piece CreateChicane()
{
 Piece Chicane;
 Chicane.ArraySize = 3;
 Chicane.PieceType = CHICANE;
 Chicane.Colour = 7;

 Chicane.PieceArray[0][0] = 0;
 Chicane.PieceArray[0][1] = 0;
 Chicane.PieceArray[0][2] = 0;
 Chicane.PieceArray[0][3] = 0; // 0 0 0
 Chicane.PieceArray[1][0] = 0; // 0 1 1
 Chicane.PieceArray[1][1] = 1; // 1 1 0
 Chicane.PieceArray[1][2] = 1;
 Chicane.PieceArray[1][3] = 0;
 Chicane.PieceArray[2][0] = 1;
 Chicane.PieceArray[2][1] = 1;
 Chicane.PieceArray[2][2] = 0;
 Chicane.PieceArray[2][3] = 0;
 Chicane.PieceArray[3][0] = 0;
 Chicane.PieceArray[3][1] = 0;
 Chicane.PieceArray[3][2] = 0;
 Chicane.PieceArray[3][3] = 0;

 return Chicane; 		       
}

Piece CreateStraight()
{
 Piece Straight;
 Straight.ArraySize = 4;
 Straight.PieceType = STRAIGHT;
 Straight.Colour = 12; 

 Straight.PieceArray[0][0] = 0;
 Straight.PieceArray[0][1] = 0;
 Straight.PieceArray[0][2] = 0;
 Straight.PieceArray[0][3] = 0;	// 0 0 0 0
 Straight.PieceArray[1][0] = 1; // 1 1 1 1
 Straight.PieceArray[1][1] = 1; // 0 0 0 0
 Straight.PieceArray[1][2] = 1; // 0 0 0 0
 Straight.PieceArray[1][3] = 1;
 Straight.PieceArray[2][0] = 0;
 Straight.PieceArray[2][1] = 0;
 Straight.PieceArray[2][2] = 0;
 Straight.PieceArray[2][3] = 0;
 Straight.PieceArray[3][0] = 0;
 Straight.PieceArray[3][1] = 0;
 Straight.PieceArray[3][2] = 0;
 Straight.PieceArray[3][3] = 0;

 return Straight; 		        
}

Piece CreateHook()
{
 Piece Hook;
 Hook.ArraySize = 3;
 Hook.PieceType = HOOK;
 Hook.Colour = 10;

 Hook.PieceArray[0][0] = 0;
 Hook.PieceArray[0][1] = 0;
 Hook.PieceArray[0][2] = 0;
 Hook.PieceArray[0][3] = 0;
 Hook.PieceArray[1][0] = 1; // 0 0 0 
 Hook.PieceArray[1][1] = 1; // 1 1 1 
 Hook.PieceArray[1][2] = 1; // 1 0 0 
 Hook.PieceArray[1][3] = 0;
 Hook.PieceArray[2][0] = 1;
 Hook.PieceArray[2][1] = 0;
 Hook.PieceArray[2][2] = 0;
 Hook.PieceArray[2][3] = 0;
 Hook.PieceArray[3][0] = 0;
 Hook.PieceArray[3][1] = 0;
 Hook.PieceArray[3][2] = 0;
 Hook.PieceArray[3][3] = 0;

 return Hook; 		
}

Piece CreateBox()
{
 Piece Box;
 Box.ArraySize = 2;
 Box.PieceType = BOX;
 Box.Colour = 11;
		 
 Box.PieceArray[0][0] = 1;
 Box.PieceArray[0][1] = 1; // 1 1
 Box.PieceArray[0][2] = 0; // 1 1
 Box.PieceArray[0][3] = 0;
 Box.PieceArray[1][0] = 1;
 Box.PieceArray[1][1] = 1;
 Box.PieceArray[1][2] = 0;
 Box.PieceArray[1][3] = 0;
 Box.PieceArray[2][0] = 0;
 Box.PieceArray[2][1] = 0;
 Box.PieceArray[2][2] = 0;
 Box.PieceArray[2][3] = 0;
 Box.PieceArray[3][0] = 0;
 Box.PieceArray[3][1] = 0;
 Box.PieceArray[3][2] = 0;
 Box.PieceArray[3][3] = 0;

 return Box; 
}	

Piece CreateCross()
{
 Piece Cross;
 Cross.ArraySize = 3;
 Cross.PieceType = CROSS;
 Cross.Colour = 13;
  			 
 Cross.PieceArray[0][0] = 0;
 Cross.PieceArray[0][1] = 0;
 Cross.PieceArray[0][2] = 0; // 0 0 0
 Cross.PieceArray[0][3] = 0; // 1 1 1
 Cross.PieceArray[1][0] = 1; // 0 1 0
 Cross.PieceArray[1][1] = 1;
 Cross.PieceArray[1][2] = 1;
 Cross.PieceArray[1][3] = 0;
 Cross.PieceArray[2][0] = 0;
 Cross.PieceArray[2][1] = 1;
 Cross.PieceArray[2][2] = 0;
 Cross.PieceArray[2][3] = 0;
 Cross.PieceArray[3][0] = 0;
 Cross.PieceArray[3][1] = 0;
 Cross.PieceArray[3][2] = 0;
 Cross.PieceArray[3][3] = 0;

 return Cross; 
}

Piece CreateReverse_Hook()
{
 Piece Reverse_Hook;
 Reverse_Hook.ArraySize = 3;
 Reverse_Hook.PieceType = REVERSE_HOOK;
 Reverse_Hook.Colour = 9;
  			 
 Reverse_Hook.PieceArray[0][0] = 0;
 Reverse_Hook.PieceArray[0][1] = 0;
 Reverse_Hook.PieceArray[0][2] = 0; // 0 0 0
 Reverse_Hook.PieceArray[0][3] = 0; // 1 1 1
 Reverse_Hook.PieceArray[1][0] = 1; // 0 0 1
 Reverse_Hook.PieceArray[1][1] = 1;
 Reverse_Hook.PieceArray[1][2] = 1;
 Reverse_Hook.PieceArray[1][3] = 0;
 Reverse_Hook.PieceArray[2][0] = 0;
 Reverse_Hook.PieceArray[2][1] = 0;
 Reverse_Hook.PieceArray[2][2] = 1;
 Reverse_Hook.PieceArray[2][3] = 0;
 Reverse_Hook.PieceArray[3][0] = 0;
 Reverse_Hook.PieceArray[3][1] = 0;
 Reverse_Hook.PieceArray[3][2] = 0;
 Reverse_Hook.PieceArray[3][3] = 0;

 return Reverse_Hook; 	
}

Piece CreateReverse_Chicane()
{
 Piece Reverse_Chicane;
 Reverse_Chicane.ArraySize = 3;
 Reverse_Chicane.PieceType = REVERSE_CHICANE;
 Reverse_Chicane.Colour = 8;

 Reverse_Chicane.PieceArray[0][0] = 0;
 Reverse_Chicane.PieceArray[0][1] = 0;
 Reverse_Chicane.PieceArray[0][2] = 0; // 0 0 0
 Reverse_Chicane.PieceArray[0][3] = 0; // 1 1 0
 Reverse_Chicane.PieceArray[1][0] = 1; // 0 1 1
 Reverse_Chicane.PieceArray[1][1] = 1;
 Reverse_Chicane.PieceArray[1][2] = 0;
 Reverse_Chicane.PieceArray[1][3] = 0;
 Reverse_Chicane.PieceArray[2][0] = 0;
 Reverse_Chicane.PieceArray[2][1] = 1;
 Reverse_Chicane.PieceArray[2][2] = 1;
 Reverse_Chicane.PieceArray[2][3] = 0;
 Reverse_Chicane.PieceArray[3][0] = 0;
 Reverse_Chicane.PieceArray[3][1] = 0;
 Reverse_Chicane.PieceArray[3][2] = 0;
 Reverse_Chicane.PieceArray[3][3] = 0;

 return Reverse_Chicane;
}

/*
Just to note:  In order to rotate, one must Transpose the array as well as some other functions.  They'll be explained in
those particular functions.

For the function below, here is the algorithm:

Take the first column.  If I'm along the diagonal of the matrix, do not flip the value.  In fact, go to the next column.
If I'm not along the diagonal, then flip the value from this column and row to that row and column.

An easy way to picture this is turn all the rows into columns.  Take the top left and the bottom right and flip the array
along the diagonal.
*/

Piece Transpose(Piece thePiece)
{
 int row, column;

 for(column=0; column < thePiece.ArraySize; column++)
 {
  for(row = 0; row < column; row++)
  {
   int temp = thePiece.PieceArray[row][column];
   thePiece.PieceArray[row][column] = thePiece.PieceArray[column][row];
   thePiece.PieceArray[column][row] = temp;
  }
 } 
 
 return thePiece;
}

/*
This one is easy.  Take the first row and the last row and exchange them.  Then take the second row and second last row and
exchange them.  Continue this until you hit the middle of the array.  
Picture this as taking the array and turning it over from top to bottom.
*/
Piece RowTransfer(Piece thePiece)
{
 int column;
 int startRow = 0;
 int endRow = thePiece.ArraySize - 1;
 
 for(startRow = 0; startRow < thePiece.ArraySize; startRow++)
 {
  if(startRow < endRow)
  {
   for(column = 0; column < thePiece.ArraySize; column++)
   {
    int temp = thePiece.PieceArray[startRow][column];
    thePiece.PieceArray[startRow][column] = thePiece.PieceArray[endRow][column];	
    thePiece.PieceArray[endRow][column] = temp;
   }
  }
  
  endRow--;
 }
 
 return thePiece;
}

/*
Same as the one above, except it turns the array over from left to right.
*/
Piece ColumnTransfer(Piece thePiece)
{
 int row;
 int startColumn = 0;
 int endColumn = thePiece.ArraySize - 1;
 
 for(startColumn = 0; startColumn < thePiece.ArraySize; startColumn++)
 {
  if(startColumn < endColumn)
  {
   for(row = 0; row < thePiece.ArraySize; row++)
   {
    int temp = thePiece.PieceArray[row][startColumn];
    thePiece.PieceArray[row][startColumn] = thePiece.PieceArray[row][endColumn];	
    thePiece.PieceArray[row][endColumn] = temp;
   }
  }
  
  endColumn--;
 }
 
 return thePiece;
}

/*
Okay, to rotate a piece clockwise, we must Transpose the matrix and then do a column transfer.  In other words, flip
along the diagonal and then turn it over again from left to right.  

In order to test this, pick up a square flat object and try it.  Flip it along the diagonal so that it's turned around
and on it's side.  Then flip it so that it's facing you again.  You'll see that it rotated clockwise 90 degrees.

Okay, an explanation for STRAIGHT, CHICANE, and REVERSE_CHICANE:

I have no set position in the array around which I can rotate.  This will result in bizarre movements.  Normally I wouldn't
care, but this program was made initially to reverse engineer the original Tetris by A. Pajitnov.  Therefore I account for
the bizarre movement.  All the other pieces can rotate about 4 times, but these three pieces only get to rotate through
two positions.  If it's in one position, I put it back to the other by rotating the other way instead.  You'll notice that
I'm checking particular positions in those piece matrices.  That is because if there IS a 1 there, it is in the position I'm
concerned about and no other possible position.
*/
Piece RotateClockwise(Piece thePiece)
{
 if(
    (thePiece.PieceType == STRAIGHT && thePiece.PieceArray[0][2] == 1) ||
    (thePiece.PieceType == CHICANE && thePiece.PieceArray[0][0] == 1) ||
    (thePiece.PieceType == REVERSE_CHICANE && thePiece.PieceArray[2][0] == 1))
    return RotateCounter_Clockwise(thePiece);	
 else
   return ColumnTransfer(Transpose(thePiece));
}

/*
For this one, flip that object along the diagonal, but this time turn it around back towards you by flipping it from top 
to bottom.
*/

Piece RotateCounter_Clockwise(Piece thePiece)
{
 if(
    (thePiece.PieceType == STRAIGHT && thePiece.PieceArray[1][3] == 1) ||
    (thePiece.PieceType == CHICANE && thePiece.PieceArray[2][0] == 1) ||
    (thePiece.PieceType == REVERSE_CHICANE && thePiece.PieceArray[2][2] == 1))
    return RotateClockwise(thePiece);
  else
    return RowTransfer(Transpose(thePiece));
}

/*
Easy, give me a random value from 0-6, and I'll give you the appropriate piece.
*/

Piece GeneratePiece(int Value)
{
 Value = Value % 7;
 if(Value == 0) return CreateChicane();
 else if(Value == 1) return CreateReverse_Chicane();
 else if(Value == 2) return CreateBox();
 else if(Value == 3) return CreateStraight();
 else if(Value == 4) return CreateReverse_Hook();
 else if(Value == 5) return CreateHook();
 else
   return CreateCross();
}


/*

These are test drivers and can be ignored.

void Print(Piece Test)
{
  int i,j;
  for(j=0; j < Test.ArraySize; j++)
  {
   printf("\n");
   for(i=0; i < Test.ArraySize; i++)
   {
    printf("%d", Test.PieceArray[j][i]);
   }
  }
}

int main()
{
 Piece Test; 
 Test = CreateChicane(Test);
 Test = RotateCounter_Clockwise(Test);
 Print(Test);
 Test = CreateReverse_Chicane(Test);
 Test = RotateCounter_Clockwise(Test);
 Print(Test);
 return 1;
}
*/
