#ifndef gf_included_raceq_h
#define gf_included_raceq_h

typedef struct raceq RaceQ;
typedef struct qnode QNode;

/*
Well, you caught me.  A raceQ is just a normal Queue.  The only difference is that I keep
track of where the tail is so that when I append, I don't have to run through the whole Q
to find the end.
*/

struct qnode
{
 int RandomValue;
 QNode* next;
};

struct raceq
{
 QNode* head;
 QNode* tail;
};

//If empty, return true.  That means I must enqueue a value before I can use it.
int isEmpty(RaceQ theQ);

//This calls dequeue a bunch of times until the Q is empty.
RaceQ freeQ(RaceQ theQ);

//This enqueues a value.  For the purpose of Tetris, this value is a random int for
//GeneratePiece.
RaceQ enqueue(RaceQ theQ, int Value);

//Give me the value at the front.  Normally after calling this, we dequeue.
int HeadValue(RaceQ theQ);

//Hmm...I really can't remember what this one does :P
RaceQ dequeue(RaceQ theQ);

#endif
