#include<allegro.h>
#include "stopkey.h"

/*
Here we initialize the keys, what to watch for and make sure they're all dirty.
*/
StopKey StartKeys(int Left, int Right, int Clock, int Counter)
{
 StopKey newKeys;

 newKeys.MoveLeft = 0;		// To start with, the player cannot move.
 newKeys.MoveRight = 0;
 newKeys.RotateClock = 0;
 newKeys.RotateCounter = 0;

 newKeys.StopLeft = 1;
 newKeys.StopRight = 1;		//If the above are zero, these are almost always 1.
 newKeys.StopClock = 1;
 newKeys.StopCounter = 1;

 newKeys.LeftKey = Left;
 newKeys.RightKey = Right;	//Here are the keys to watch for.
 newKeys.ClockKey = Clock;
 newKeys.CounterKey = Counter;

 return newKeys;
}

StopKey MoveAround(StopKey theKeys)
{
 theKeys.MoveLeft = 0;
 theKeys.MoveRight = 0;		//To start with, you aren't allowed to move.
 theKeys.RotateClock = 0;
 theKeys.RotateCounter = 0;
  
 if(!key[theKeys.LeftKey]) theKeys.StopLeft = 0;	//If the player isn't pressing
 if(!key[theKeys.RightKey]) theKeys.StopRight = 0;	//any one of these keys, then
 if(!key[theKeys.CounterKey]) theKeys.StopCounter = 0;	// we clean the key.
 if(!key[theKeys.ClockKey]) theKeys.StopClock = 0;


 //If the key is clean and the player is pressing it, we tell the driver that the player
 //wants to move in that direction and then we dirty the key so that the player can't move
 //that same way with the same keypress.
 if((key[theKeys.LeftKey]) && theKeys.StopLeft == 0)
 {
  theKeys.MoveLeft = 1;
  theKeys.StopLeft = 1;
 }
 else if((key[theKeys.RightKey]) && theKeys.StopRight == 0)
 {
  theKeys.MoveRight = 1;
  theKeys.StopRight = 1;
 } 
 else if(key[theKeys.CounterKey] && theKeys.StopCounter == 0)
 {
  theKeys.RotateCounter = 1;
  theKeys.StopCounter = 1;
 }
 else if(key[theKeys.ClockKey] && theKeys.StopClock == 0)
 {
  theKeys.RotateClock = 1;
  theKeys.StopClock = 1;
 }

 return theKeys;
}

