#ifndef gf_included_stopkey_h
#define gf_included_stopkey_h

struct stopkey
{
 int MoveLeft;
 int MoveRight;
 int RotateClock;
 int RotateCounter;

 int LeftKey;
 int RightKey;
 int ClockKey;
 int CounterKey;

 int StopLeft;
 int StopRight;
 int StopClock;
 int StopCounter;
};

typedef struct stopkey StopKey;

/*
Okay, the whole point to this code was simply this:
-I couldn't turn of the keyboard repeat, thanks to Allegro (sigh).
-If you hold down the key, then the piece moves at an uncontrollable speed.
-I'm reverse-engineering the original one for the gameboy, which did not allow repeats 
unless you pressed down.

Okay, so this is how it works.  First we tell the StopKey just what keys this player is
going to be using.  It only concerns itself with left, right, and rotate.

If the player presses a key, then we dirty the key until he lets go.  As long as the key
is dirty, the driver will ignore the keypress.  

*/

//This tells StopKey what to watch.
StopKey StartKeys(int Left, int Right, int Clock, int Counter);
//This watches for new keypresses and dirties or cleans old ones.
StopKey MoveAround(StopKey theKeys);

#endif
