#include <allegro.h>
#include <conio.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "gamegrid.h"
#include "stopkey.h"
#include "setup.h"
#include "paint.h"
#include "textv.h"

volatile int Down = 0;
volatile int Down2 = 0;

int Player1TakeMeDown = 0;
int Player2TakeMeDown = 0;

int Player1Column = 5;
int Player2Column = 46;

GameGrid Player1Tetris;
GameGrid Player2Tetris;

void inc_Down(void)
{
   Down++;
   Down2++;
   if(Player1TakeMeDown)
   {
    Player1TakeMeDown = 3;
   }
   if(Player2TakeMeDown)
   {
    Player2TakeMeDown = 3;
   }

   if(Down >= Player1Tetris.Speed && Down >= 8)
   {
     Down = 0;
     Player1TakeMeDown = 3;
   }

   if(Down2 >= Player2Tetris.Speed && Down2 >= 8)
   {
     Down2 = 0;
     Player2TakeMeDown = 3;
   }
}

END_OF_FUNCTION(inc_Down);


void MakeNextPiece()
{
   if(Player1Tetris.NeedNewPiece || Player2Tetris.NeedNewPiece)
   {
     int nextValue = (rand() + Player1Tetris.Score + Player2Tetris.Score) % 7;
     if(isEmpty(Player1Tetris.PieceQ) || isEmpty(Player2Tetris.PieceQ))
     {
      Player1Tetris.PieceQ = enqueue(Player1Tetris.PieceQ, nextValue);
      Player2Tetris.PieceQ = enqueue(Player2Tetris.PieceQ, nextValue);
     }
             
     if(Player1Tetris.NeedNewPiece)
     {
      Player1Tetris.NextPiece = GeneratePiece(HeadValue(Player1Tetris.PieceQ));
      Player1Tetris.PieceQ = dequeue(Player1Tetris.PieceQ);
      Player1Tetris.NeedNewPiece = 0;
      paint(Player1Tetris,Player1Column);
     }
     if(Player2Tetris.NeedNewPiece)
     {
      Player2Tetris.NextPiece = GeneratePiece(HeadValue(Player2Tetris.PieceQ));
      Player2Tetris.PieceQ = dequeue(Player2Tetris.PieceQ);
      Player2Tetris.NeedNewPiece = 0;
      paint(Player2Tetris,Player2Column);
     }
   }
}


void BeginGaming(VersusSetup GameOptions)
{ 
 StopKey Player1Keys = StartKeys(GameOptions.Player1Left, GameOptions.Player1Right, GameOptions.Player1RotateClock, GameOptions.Player1RotateCounter);
 StopKey Player2Keys = StartKeys(GameOptions.Player2Left, GameOptions.Player2Right, GameOptions.Player2RotateClock, GameOptions.Player2RotateCounter);

 LOCK_VARIABLE(Down);
 LOCK_VARIABLE(Down2);
 LOCK_FUNCTION(inc_Down);

 int Quit = 0;
 while((GameOptions.Player1MatchPoints < GameOptions.TotalMatchPoints) && (GameOptions.Player2MatchPoints < GameOptions.TotalMatchPoints) && Quit == 0)
 {
  clrscr();

  install_int(inc_Down, 10);

  Player1Tetris = InitializeGrid(GameOptions.Player1StartLevel, GameOptions.Player1MaxLevel, GameOptions.LinesClear);
  Player2Tetris = InitializeGrid(GameOptions.Player2StartLevel, GameOptions.Player2MaxLevel, GameOptions.LinesClear); 

  Player1Tetris = NextPiece(Player1Tetris);
  Player2Tetris = NextPiece(Player2Tetris);
 
  paint(Player1Tetris, Player1Column);
  paint(Player2Tetris, Player2Column);
  paintPoints(GameOptions.Player1MatchPoints, Player1Column, GameOptions.TotalMatchPoints);
  paintPoints(GameOptions.Player2MatchPoints, Player2Column, GameOptions.TotalMatchPoints);

  while (!(key[KEY_ESC]) && !Player1Tetris.Lose && !Player2Tetris.Lose) 
	 {
	  MakeNextPiece();

 	  if(!(key[GameOptions.Player1Down])) Player1Tetris.GoDown = 1;
	  if(!(key[GameOptions.Player2Down])) Player2Tetris.GoDown = 1;
	
	  if(((key[GameOptions.Player1Down] && Player1Tetris.GoDown == 1) || Player1TakeMeDown == 3) ||
              ((key[GameOptions.Player2Down] && Player2Tetris.GoDown == 1) || Player2TakeMeDown == 3))
	  {
	   if(key[GameOptions.Player1Down] && Player1Tetris.GoDown == 1) 
             Player1Tetris.Score += Player1Tetris.CurrentLevel;
	   if(key[GameOptions.Player2Down] && Player2Tetris.GoDown == 1) 
		Player2Tetris.Score += Player2Tetris.CurrentLevel;

           if((key[GameOptions.Player1Down] && Player1Tetris.GoDown == 1) || Player1TakeMeDown == 3)
           {
  	    Player1Tetris = MoveDown(Player1Tetris);
            if(Player1Tetris.ScoreCounter > 1) 
	    {
		Player2Tetris.BumpMeUp += Player1Tetris.ScoreCounter - 1;
                if(Player2Tetris.BumpMeUp > 3) Player2Tetris.BumpMeUp = 3;
		Player1Tetris.ScoreCounter = 0;
	    }
  
            Player1TakeMeDown = 0;
           }

           if((key[GameOptions.Player2Down] && Player2Tetris.GoDown == 1) || Player2TakeMeDown == 3)
           {
	    Player2Tetris = MoveDown(Player2Tetris);
            if(Player2Tetris.ScoreCounter > 1) 
	    {
		Player1Tetris.BumpMeUp += Player2Tetris.ScoreCounter - 1;
                if(Player1Tetris.BumpMeUp > 3) Player1Tetris.BumpMeUp = 3;
		Player2Tetris.ScoreCounter = 0;
	    }

	    Player2TakeMeDown = 0;
	   }

	    paint(Player1Tetris,Player1Column);
	    paint(Player2Tetris,Player2Column);
	    rest(10);
	  }
	
	  Player1Keys = MoveAround(Player1Keys);
          Player2Keys = MoveAround(Player2Keys);
	
	  if(Player1Keys.MoveLeft)
	  {
	    Player1Tetris = MoveLeft(Player1Tetris);
	    paint(Player1Tetris,Player1Column);
	    rest(10);
	  }
	  if(Player1Keys.MoveRight)
	  {
	    Player1Tetris = MoveRight(Player1Tetris);	
	    paint(Player1Tetris,Player1Column);
	    rest(10);
	  }
	  if(Player1Keys.RotateCounter)
	  {
	    Player1Tetris = Counter_Clockwise(Player1Tetris);	
	    paint(Player1Tetris,Player1Column);
	    rest(10);
	  }
	  if(Player1Keys.RotateClock)
	  {
	    Player1Tetris = Clockwise(Player1Tetris);	
	    paint(Player1Tetris,Player1Column);
	    rest(10);
	  }  
	  if(Player2Keys.MoveLeft)
	  {
	    Player2Tetris = MoveLeft(Player2Tetris);
	    paint(Player2Tetris,Player2Column);
	    rest(10);
	  }
	  if(Player2Keys.MoveRight)
	  {
	    Player2Tetris = MoveRight(Player2Tetris);	
	    paint(Player2Tetris,Player2Column);
	    rest(10);
	  }
	  if(Player2Keys.RotateCounter)
	  {
	    Player2Tetris = Counter_Clockwise(Player2Tetris);	
	    paint(Player2Tetris,Player2Column);
	    rest(10);
	  }
	  if(Player2Keys.RotateClock)
	  {
	    Player2Tetris = Clockwise(Player2Tetris);	
	    paint(Player2Tetris,Player2Column);
	    rest(10);
	  }  
	  clear_keybuf();
	 }
  remove_int(inc_Down);
  paint(Player1Tetris,Player1Column);
  paint(Player2Tetris,Player2Column);

  Player1Tetris.PieceQ = freeQ(Player1Tetris.PieceQ);
  Player2Tetris.PieceQ = freeQ(Player2Tetris.PieceQ);

  gotoxy(27,20);
  if(Player1Tetris.Lose) 
  {
   printf("Player 2 Wins!");
   GameOptions.Player2MatchPoints++;
  }
  else if(Player2Tetris.Lose) 
  {
   printf("Player 1 Wins!");
   GameOptions.Player1MatchPoints++;
  }
  else Quit = 1;

  if(Quit != 1)
  {
    paintPoints(GameOptions.Player1MatchPoints, Player1Column, GameOptions.TotalMatchPoints);
    paintPoints(GameOptions.Player2MatchPoints, Player2Column, GameOptions.TotalMatchPoints);
    rest(1000);
    clear_keybuf();
    readkey();
    clear_keybuf();
  }
 }
 textcolor(7);
 clrscr();
}


int main()
{
 srand( (unsigned)time( NULL ) );	
 allegro_init();
 install_timer();
 install_keyboard();	
 _setcursortype ( _NOCURSOR ) ;
 clrscr();
 VersusSetup GameOptions = MenuSystem();

 if(GameOptions.Begin == 1) BeginGaming(GameOptions);

 gotoxy(0,23);
 _setcursortype ( _NORMALCURSOR ); 
 allegro_exit();
 return 0;
}
